/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  CertificateRepository
  Package: repository
  File:    CertificateRepository.java
*/

package fi.hut.tcm.repository;
import java.security.cert.Certificate;
import java.util.Vector;

/**
  CertificateRepository
  
  Abstract class for storing certificates.
*/
public abstract class CertificateRepository
  extends Object {

  /**
  */
  private String type;

  /**
  */
  protected CertificateRepository(String type) {

  //+ CertificateRepository::CertificateRepository(String)
    this.type = type;
  //- CertificateRepository::CertificateRepository(String)
  }

  /**
    Loads the repository.
  */
  public abstract void load()
    throws Exception;

  /**
    Adds the cert to the repository.
  */
  public abstract void add(Certificate cert)
    throws Exception;
  
  /**
    Removes the cert from the repository, if it has been stored there.
  */
  public abstract void remove(Certificate cert)
    throws Exception;
  
  /**
    Returns a vector of all the certificates that have been issued by the 
    issuer.
  */
  public abstract Vector getCertsByIssuer(Object issuer)
    throws Exception;
  
  /**
    Returns a vector of  all the certificates that have been issued to the 
    subject.
  */
  public abstract Vector getCertsBySubject(Object subject)
    throws Exception;
  
  /**
    Saves the repository.
  */
  public abstract void save()
    throws Exception;

} // CertificateRepository

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
