/**
  Copyright (C) 1998 Jonna Partanen. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  ByteString
  Package: spki
  File:    ByteString.java
*/

package fi.hut.tcm.spki;
import fi.hut.tcm.spki.*;


/**
  ByteString
  
  
*/
public class ByteString
  extends Object
  implements Component {

  /**
    This is a display hint for this individual field.
  */
  private byte[] displayType;
  
  /**
  */
  private byte[] bytes;
  
  /**
  */
  public ByteString() {
  
  //+ ByteString::ByteString( )
    displayType = new byte[0];
    bytes = new byte[0];
 //- ByteString::ByteString( )
  }
  
  /**
  */
  public ByteString(byte[] value) {
  
  //+ ByteString::ByteString(byte[])
    bytes = value;
    displayType = new byte[0];
  //- ByteString::ByteString(byte[])
  }
  
  /**
  */
  public ByteString(String value) {
  
  //+ ByteString::ByteString(String)
    bytes = value.getBytes();
    displayType = new byte[0];
  //- ByteString::ByteString(String)
  }
  
  /**
  */
  public ByteString(byte[] value, byte[] display) {
  
  //+ ByteString::ByteString(byte[], byte[])
    bytes = value;
    displayType = display;
  //- ByteString::ByteString(byte[], byte[])
  }
  
  /**
  */
  public ByteString(String value, String display) {
  
  //+ ByteString::ByteString(String, String)
    bytes = value.getBytes();
    displayType = display.getBytes();
  //- ByteString::ByteString(String, String)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ ByteString::accept(Visitor)
    visitor.at(this);
  //- ByteString::accept(Visitor)
  }
  
  /**
  */
  public void setDisplayHint(byte[] display) {
  
  //+ ByteString::setDisplayHint(byte[])
    displayType = display;
  //- ByteString::setDisplayHint(byte[])
  }
  
  /**
  */
  public void setDisplayHint(String display) {
  
  //+ ByteString::setDisplayHint(String)
    displayType = display.getBytes();
  //- ByteString::setDisplayHint(String)
  }
  
  /**
  */
  public byte[] getDisplayHintBytes() {
  
  //+ ByteString::getDisplayHint( )
    return displayType;
  //- ByteString::getDisplayHint( )
  }
  
  /**
  */
  public String getDisplayHintString() {
  
  //+ ByteString::getDisplayHint( )
    return new String(displayType);
  //- ByteString::getDisplayHint( )
  }
  
  /**
    Sets the value of the ByteString.
    
    Subclasses with content constraints may override this method and throw 
    a SPKIException if trying to set an illegal value.
  */
  public void setValue(byte[] string)
    throws SPKIException  {
  
  //+ ByteString::setValue(byte[])
      bytes = string;
  //- ByteString::setValue(byte[])
  }
  
  /**
    Sets the value of the ByteString.
    
    Subclasses with content constraints may override this method and throw 
    a SPKIException if trying to set an illegal value.
  */
  public void setValue(String string)
    throws SPKIException  {
  
  //+ ByteString::setValue(String)
    bytes = string.getBytes();
  //- ByteString::setValue(String)
  }
  
  /**
  */
  public byte[] getValueBytes() {
  
  //+ ByteString::getValueBytes( )
    return bytes;
  //- ByteString::getValueBytes( )
  }
  
  /**
  */
  public String getValueString() {
  
  //+ ByteString::getValueString( )
    return new String(bytes);
  //- ByteString::getValueString( )
  }
  
  /**
  */
  public String toString() {
  
  //+ ByteString::toString( )
    if (displayType.length != 0) {
      String result = new String("[" + getDisplayHintString() + 
				 "] " + getValueString());
      return result;
    } else {
      return new String(bytes);
    }
  //- ByteString::toString( )
  }
  
  /**
  */
  public boolean equals(Object other) {
  
  //+ ByteString::equals(Object)
    if ((other instanceof ByteString) && 
	(((ByteString)other).getValueString().equals(getValueString())) && 
	(((ByteString)other).getDisplayHintString().equals(getDisplayHintString())))
      return true;
    else 
      return false;
  //- ByteString::equals(Object)
  }
  
} // ByteString

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
