/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  GeneralOp
  Package: impl
  File:    GeneralOp.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;
import fi.hut.tcm.spki.format.*;

/**
  GeneralOp
  
  Operation command other than Hash-operation. Consists of a ByteString 
  followed by an arbitrary number of SParts.
*/
public class GeneralOp
  extends Composite
  implements Op, SeqEnt, fi.hut.tcm.spki.Composite, Component {

  /**
  */
  public GeneralOp() {
  
  //+ GeneralOp::GeneralOp( )
    super();
  //- GeneralOp::GeneralOp( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ GeneralOp::check(Component)
      if (!(addition instanceof SPart) &&
	  !(addition instanceof ByteString &&
	    !addition.getClass().getSuperclass().getName().equals
	    ((new ByteString()).getClass().getName())))
	return false;
      if ((addition instanceof ByteString) &&
	  (children.size() == 0))
	return true;
      if ((addition instanceof SPart) &&
	  (children.size() != 0))
	return true;
      throw new IllegalStateException();
  //- GeneralOp::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ GeneralOp::accept(Visitor)
    visitor.at(this);
  //- GeneralOp::accept(Visitor)
  }
  
} // GeneralOp

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
