/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  HashAlgName
  Package: impl
  File:    HashAlgName.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  HashAlgName
  
  A name of a hash algorithm. Contains an Uri or a ByteString. Possible 
  ByteString values include "md5" and "sha1".
*/
public class HashAlgName
  extends Composite {

  /**
  */
  public HashAlgName() {
  
  //+ HashAlgName::HashAlgName( )
    super();
  //- HashAlgName::HashAlgName( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ HashAlgName::check(Component)
      if (!(addition instanceof Uri) &&
	  !(addition instanceof ByteString &&
	    !addition.getClass().getSuperclass().getName().equals
	    ((new ByteString()).getClass().getName())))
	return false;
      if (children.size() == 0)
	return true;
      throw new IllegalStateException();
  //- HashAlgName::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ HashAlgName::accept(Visitor)
    visitor.at(this);
  //- HashAlgName::accept(Visitor)
  }
  
  /**
  */
  public String toString() {
  
  //+ HashAlgName::toString( )
    String result = new String();
    for (int i = 0; i < size(); i++) {
      result += children.elementAt(i).toString();
      if (i < (size() - 1))
	result += " ";
    }
    return result;
  //- HashAlgName::toString( )
  }
  
} // HashAlgName

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
