/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  KVal
  Package: impl
  File:    KVal.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;

/**
  KVal
  
  The number of subjects needed to get the authority.
*/
class KVal
  extends ByteString {

  /**
  */
  public KVal() {
  
  //+ KVal::KVal( )
    super();
  //- KVal::KVal( )
  }
  
  /**
  */
  public KVal(byte[] value) {
  
  //+ KVal::KVal(byte[])
    super();
    try {
      setValue(value);
    } catch (SPKIException e) {
      System.err.println(e.toString()); // Never reached.
    }
  //- KVal::KVal(byte[])
  }
  
  /**
  */
  public KVal(String value) {
  
  //+ KVal::KVal(String)
    super();
    try {
      setValue(value);
    } catch (SPKIException e) {
      System.err.println(e.toString()); // Never reached.
    }
  //- KVal::KVal(String)
  }
  
  /**
  */
  public KVal(byte[] value, byte[] display) {
  
  //+ KVal::KVal(byte[], byte[])
    super();
    try {
      setValue(value);
      setDisplayHint(display);
    } catch (SPKIException e) {
      System.err.println(e.toString()); // Never reached.
    }
  //- KVal::KVal(byte[], byte[])
  }
  
  /**
  */
  public KVal(String value, String display) {
  
  //+ KVal::KVal(String, String)
    super();
    try {
      setValue(value);
      setDisplayHint(display);
    } catch (SPKIException e) {
      System.err.println(e.toString()); // Never reached.
    } 
  //- KVal::KVal(String, String)
  }
  
  /**
  */
  public String toString() {
  
  //+ KVal::toString( )
    return super.toString();
  //- KVal::toString( )
  }
  
  /**
  */
  public boolean equals(Object other) {
  
  //+ KVal::equals(Object)
    if ((other instanceof KVal) && 
	(((KVal)other).getValueString().equals(getValueString())) && 
	(((KVal)other).getDisplayHintString().equals(getDisplayHintString())))
      return true;
    else 
      return false;
  //- KVal::equals(Object)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ KVal::accept(Visitor)
    visitor.at(this);
  //- KVal::accept(Visitor)
  }
  
} // KVal

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
