/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  SPKIProvider
  Package: impl
  File:    SPKIProvider.java
*/

package fi.hut.tcm.spki.impl;
import java.security.Provider;
import java.security.AccessController;

/**
  SPKIProvider
  
  The SPKIProvider supplies the CertificateFactory.SPKI service.
*/
public final class SPKIProvider
  extends Provider {

  /**
    A description of the provider and its services.
  */
  private String info = "TeSSA.tcm.hut.fi SPKIProvider v. 0, implements SPKI certificates";
  
  /**
    The provider version number.
  */
  private double version = 0;
  
  /**
    The provider name.
  */
  private String name = "TeSSA.tcm.hut.fi SPKIProvider";
  
  /**
    Declare serialVersionUID to be compatible with JDK1.1
  */
  static long serialVersionUID;
  
  /**
  */
  public SPKIProvider() {
  
  //+ SPKIProvider::SPKIProvider( )
    super("TeSSA.tcm.hut.fi SPKIProvider v. 0, implements SPKI certificates", 
	  0, "TeSSA.tcm.hut.fi SPKIProvider");

    AccessController.doPrivileged(new java.security.PrivilegedAction() {
      public Object run() {
	put("Certificate.SPKI", "fi.hut.tcm.spki.impl.SpkiCert");
	put("CertificateFactory.SPKI", "fi.hut.tcm.spki.impl.SpkiCertFactory");

	return null;
      };
    });
  //- SPKIProvider::SPKIProvider( )
  }
  
  /**
    Returns the name of this provider.
  */
  public final String getName() {
  //+ SPKIProvider::getName( )
	return name;
  //- SPKIProvider::getName( )
  }
  
  /**
    Returns the version number for this provider.
  */
  public final double getVersion() {
  //+ SPKIProvider::getVersion( )
	return version;
  //- SPKIProvider::getVersion( )
  }
  
  /**
  */
  public String getInfo() {
  //+ SPKIProvider::getInfo( )
	return info;
  //- SPKIProvider::getInfo( )
  }
  
  /**
    Returns a string with the name and the version number
    of this provider.
  */
  public final String toString() {
  //+ SPKIProvider::toString( )
	return info;
  //- SPKIProvider::toString( )
  }
  
} // SPKIProvider

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
