/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  SPart
  Package: impl
  File:    SPart.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;
import fi.hut.tcm.spki.format.*;

/**
  SPart
  
  SPart is a part of an S-Expression. It contains either an instance of 
  ByteString or an instance of SExpr.
*/
class SPart
  extends Composite {

  /**
  */
  public SPart() {
  
  //+ SPart::SPart( )
    super();
  //- SPart::SPart( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ SPart::check(Component)
      if (!(addition instanceof SExpr) &&
	  !(addition instanceof ByteString &&
	    !addition.getClass().getSuperclass().getName().equals
	    ((new ByteString()).getClass().getName())))
 	return false;
      if (children.size() == 0)
	return true;
      throw new IllegalStateException();
   //- SPart::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ SPart::accept(Visitor)
    visitor.at(this);
  //- SPart::accept(Visitor)
  }
  
  /**
  */
  public String toString() {
  
  //+ SPart::toString( )
    String result = new String();
    for (int i = 0; i < size(); i++) {
      result += children.elementAt(i).toString();
      if (i < (size() - 1))
	result += " ";
    }
    return result;
  //- SPart::toString( )
  }
  
} // SPart

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
