/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  SecKey
  Package: impl
  File:    SecKey.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;
import fi.hut.tcm.spki.format.*;
import java.security.*;
import java.security.spec.*;
import java.security.interfaces.*;
import java.math.BigInteger;

/**
    SecKey
    
    Shared Secret Key class. Contains a SecSigAlgId followed by an
    arbitrary number of SExpr:s followed by on optional Uri. SExpr:s
    contain the key data and the Uri is a pointer to additional key info.
*/
public class SecKey
  extends Composite
  implements Key, SeqEnt, java.security.Key {

  /**
  */
  public SecKey() {
  
  //+ SecKey::SecKey( )
    super();
  //- SecKey::SecKey( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ SecKey::check(Component)
      if (!(addition instanceof SecSigAlgId) &&
	  !(addition instanceof SExpr) &&
	  !(addition instanceof Uri))
	return false;
      if (children.size() == 0)
	if (addition instanceof SecSigAlgId)
	  return true;
	else
	  throw new IllegalStateException();
      if ((children.size() != 0) &&
	  (addition instanceof SecSigAlgId))
	throw new IllegalStateException();
      if ((children.size() == 1) &&
	  (addition instanceof Uri))
	throw new IllegalStateException();
      if (get(children.size() - 1) instanceof Uri)
	throw new IllegalStateException();
      return true;
  //- SecKey::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ SecKey::accept(Visitor)
      visitor.at(this);
  //- SecKey::accept(Visitor)
  }
  
  /**
  */
  public String getAlgorithm() {
  
  //+ PubKey::getAlgorithm( )
    return null;
  //- PubKey::getAlgorithm( )
  }
  
  /**
  */
  public byte[] getEncoded() {
  
  //+ PubKey::getEncoded( )
    return null;
  //- PubKey::getEncoded( )
  }
  
  /**
  */
  public String getFormat() {
  
  //+ PubKey::getFormat( )
    return null;
  //- PubKey::getFormat( )
  }

} // SecKey

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
