/**
  Copyright (C) 1998 XYZ, Inc. All rights Reserved.
  XXX   %Z%%M% version %I% date:%G%
  Component:  Sig
  Package: impl
  File:    Sig.java
*/

package fi.hut.tcm.spki.impl;
import fi.hut.tcm.spki.*;
import fi.hut.tcm.spki.format.SeqEnt;

/**
  Sig
  
  Signature of a previous sequence object. Contains a Hash of the object, 
  the signing SpkiPrincipal and the SigVal, in that order.
*/
public class Sig
  extends Composite
  implements SeqEnt {

  /**
  */
  public Sig() {
  
  //+ Sig::Sig( )
    super();
  //- Sig::Sig( )
  }
  
  /**
  */
  public boolean check(Component addition)
    throws IllegalStateException  {
  
  //+ Sig::check(Component)
      if (!(addition instanceof Hash) &&
	  !(addition instanceof SpkiPrincipal) &&
	  !(addition instanceof SigVal))
	return false;
      if ((children.size() == 0) &&
	  (addition instanceof Hash))
	return true;
      if ((children.size() == 1) &&
	  (addition instanceof SpkiPrincipal))
	return true;
      if ((children.size() == 2) &&
	  (addition instanceof SigVal))
	return true;
      throw new IllegalStateException();
  //- Sig::check(Component)
  }
  
  /**
  */
  public void accept(Visitor visitor) {
  
  //+ Sig::accept(Visitor)
      visitor.at(this);
  //- Sig::accept(Visitor)
  }
  
  /**
  */
  public String toString() {
  
  //+ Sig::toString( )
    String result = new String("(signature");
    for (int i = 0; i < size(); i++)
      result = new String(result + " " + get(i).toString());
    return new String(result + ")");
  //- Sig::toString( )
  }
  
} // Sig

// +*************** UNUSED CODE ***************
// -*************** UNUSED CODE ***************
